/*
 * bbbutton.c
 *
 * (C) 29-11-2002 Konstantinos Mantzaris <GODoal@hotmail.com>
 *
 * This software is under GPL v2
 *
 * Part of this code is striped from wmNetscapeKiller
 * by Pierre-Olivier <pblumo@free.fr>
 * 
 */

#include "bbbutton.h"

class BBButton {
    public :    
	BBButton(char Image[64], char Command[64]); 
	~BBButton(){}
	void killIt();
	void runEvents();
	void BPressed();
	void BReleased();
    protected :
	char xpmPath[64];
	char procCMD[64];
};

class BBBrc {
    public :
	BBBrc() { rcName = new char[strlen(homedir) + 32];
		  sprintf(rcName, "%s/.bbbuttonrc", homedir); }
	//BBBrc(char * fileName) { 
	//	rcName = new char[strlen(homedir)+32];
	//      sprintf(rcName, "%s/%s", homedir,filename); }
	~BBBrc() {}
	int getLineNo();
	void runButtons(BBButton **);
    protected :
	char * rcName;
	int lines;
	char picPath[64];
        char picCMD[64];
};   

BBButton * aBBButton[20];

BBButton :: BBButton( char Image[64], char Command[64] ) {

    strncpy(xpmPath, Image, sizeof(xpmPath));
    strncpy(procCMD, Command, sizeof(procCMD));

    if( ( display = XOpenDisplay(NULL) ) == NULL ){
	cerr<<"Error: XOpenDisplay "<<endl;
	exit(1);
    }
    
    root = RootWindow(display, screen = DefaultScreen(display));
    fgcolor = BlackPixel(display, screen);
    bgcolor = WhitePixel(display, screen);
    gc = XDefaultGC(display, screen);
    
    sizeHints.x = 0;
    sizeHints.y = 0;
    sizeHints.width = 64;
    sizeHints.height = 64;

    win = XCreateSimpleWindow(display, root, sizeHints.x, 
			                     sizeHints.y,
			                     sizeHints.width,
			                     sizeHints.height,
			                     depth, fgcolor, bgcolor);
    iconwin = XCreateSimpleWindow(display, root, sizeHints.x,
			                         sizeHints.y,
			                         sizeHints.width,
			                         sizeHints.height,
			                         depth, fgcolor, bgcolor);

    sizeHints.flags = USSize | USPosition;
    XSetWMNormalHints(display, win, &sizeHints);

    
    wmHints.initial_state = WithdrawnState;
    wmHints.icon_window = iconwin;
    wmHints.icon_x = sizeHints.x;
    wmHints.icon_y = sizeHints.y;
    wmHints.window_group = win;
    wmHints.flags = StateHint|IconWindowHint|IconPositionHint|WindowGroupHint;
    XSetWMHints(display, win, &wmHints);

    classHint.res_name = "bbbutton";
    classHint.res_class = "bbbutton";
    XSetClassHint(display, win, &classHint);

    XpmReadFileToData(Image,&xpm_data);
    XpmCreatePixmapFromData(display, root, xpm_data,&XPM, &pixmask,NULL);
    XShapeCombineMask(display, iconwin, ShapeBounding, 8, 8, pixmask, ShapeSet);

    XSelectInput(display, win, eventmask);
    XSelectInput(display,iconwin, eventmask);
    XMapWindow(display, win);
}

//void BBButton :: killIt() {
    //XDestroyWindow(display, win);
//    XCloseDisplay(display);
//}

void BBButton :: BPressed() {
    XCopyArea(display, XPM, iconwin, gc,0,0,48,48,9,9);		
    system(procCMD);
}

void BBButton :: BReleased() {
    XCopyArea(display, XPM, iconwin, gc,0,0,48,48,8,8);
}

void BBButton :: runEvents() {
    for(;;){
	XNextEvent(display, &event);
	switch(event.type){
    	    case Expose:
		BReleased();
		break;
	    case ButtonPress:
		switch(event.xbutton.button ){
		    case 1: //left click
			BPressed();
			break;
		    case 3: //right click
			//killIt();
			break;
		    default: 	break;
		}
		break;
	    case MotionNotify:
		if(event.xmotion.state & Button1Mask){
		    sleep(1);
		    break;
		}
		break;
	    case ButtonRelease:
		switch(event.xbutton.button){
		    case 1:
			BReleased();
			break;
		    default:	break;
		}
    		break;
	}
    }	
}

int BBBrc :: getLineNo(){
    int lines=0;
    char ch;

    ifstream fin(rcName,ios::in);
    if(!fin){ cout<<"Unable to open .bbbuttonrc for reading.\n"; exit(1); }
    while( fin.get(ch) ) { if(ch=='\n') ++lines; }
    fin.close();
    return lines;
}

void BBBrc :: runButtons(BBButton * aBBButton[20]){
    int pid, count = 0;
    do{
        ifstream fin(rcName,ios::in);
        if(!fin){ cout<<"Unable to open .bbbuttonrc for reading.\n"; exit(1) ;}
        for(int i=0; i<count; i++){ fin.ignore(1024,'\n'); }
        fin.getline(picPath,64,'\040');
        fin.getline(picCMD,64,'\n');
        fin.close();

        aBBButton[count] = new BBButton(picPath,picCMD);
	cout<<"BBButon number "<<aBBButton[count]<<endl;
        pid = fork();	
        if(pid == -1) cout<<"bbbutton: Could not fork event window\n";
        if(pid == 0) aBBButton[count]->runEvents();

        count++;
    }while(count < this->getLineNo());    
}

int main(int argc, char ** argv) {

    char * pname = argv[0];
    
    if(argc==3){
	strncpy(xpmPath, argv[1], sizeof(xpmPath));
	strncpy(procCMD, argv[2], sizeof(procCMD));
	aBBButton[0] = new BBButton(xpmPath,procCMD);
	aBBButton[0]->runEvents();
    }
    if(argc == 1){
	cout<<"Loading data from .bbbuttonrc ...\n";
	BBBrc bbbrc;
	bbbrc.runButtons( aBBButton );
    }
    else {
    cout<<"\n+-----------------------------------------------------------------+\n"
        <<"  Usage : "<<pname<<" [path to .xpm image] [command]                \n"
        <<"      i.e "<<pname<<" /somewhere/xmms.xpm  \042xmms &\042           \n"
        <<"      or just "<<pname<<" if you're using a .bbbuttonrc conf file   \n"
        <<"\n"
        <<"  "<<pname<<" v0.7 ,by Konstantinos Mantzaris (GODoal@hotmail.com)  \n"  
        <<"+-----------------------------------------------------------------+\n";
    }
}
